/******************************************************************************
Filename:     modAdcSimpleImpl.h
Target:       cc2530

Description:
H.Zheng 802.15.4 building block layer module library: ADC part

modification:
2012.10.02 creation Zheng Hui (wrap TI's adc.c)

******************************************************************************/
#include "modAdc.h"
#include <iocc2530.h>
#include "hal_defs.h"

#define ADC_ENABLE_CHANNEL(ch)   ADCCFG |=  (0x01 << ch)
#define ADC_DISABLE_CHANNEL(ch)  ADCCFG &= ~(0x01 << ch)
#define ADC_SINGLE_CONVERSION(settings) st( ADCCON3 = (settings); )


/**
 * ADCɼ
 */
int16 modAdcSampleSingle(uint8 vReference, uint8 vResolution, uint8 vChannel) {
  int16 value;

  ADC_ENABLE_CHANNEL(vChannel);

  ADCIF = 0;
  ADC_SINGLE_CONVERSION(vReference | vResolution | vChannel);
  while(!ADCIF);

  value  = (ADCH << 8) & 0xff00;
  value |= ADCL;

  ADC_DISABLE_CHANNEL(vChannel);

  //  The variable 'value' contains 16 bits where
  //     bit 15 is a sign bit
  //     bit [14 .. 0] contain the absolute sample value
  //     Only the r upper bits are significant, where r is the resolution
  //     Resolution:
  //        12   -> [14 .. 3] (bitmask 0x7FF8)
  //        10   -> [14 .. 5] (bitmask 0x7FE0)
  //         9   -> [14 .. 6] (bitmask 0x7FC0)
  //         7   -> [14 .. 8] (bitmask 0x7F00)

  return value;
}

