/******************************************************************************
Filename:     modHwExtSimpleImpl.c
Target:       cc2430
Revised:      2008.01.05
Revision:     0.10

Description:
H.Zheng 802.15.4 building block layer module library: system part

һּ򵥵modHwExt.hӿڵʵַʽ(LED part)
ṩCC2430ذ塣

modification:
2008.1.14 creation Zheng Hui
2011.05.14 add ioCC2530.h for CC2530
2012.05.06 ¶Ĺӿ޸
2012.06.27 add LED3: P1_2
2014.11.03 renamed to modLedImpl.c

COPYRIGHT
Zheng Hui, Guangzhou, China. hzheng@gzhu.edu.cn. Guangzhou University

******************************************************************************/
#include "modHwExt.h"
#include <ioCC2530.h>


#define LED1          P1_0
#define LED2          P1_1
#define LED3          P1_2
#define LED_OFF          1
#define LED_ON           0


/**
 * LEDʼӿ
 * עLEDĿӦӲء
 */
int8 modLedInit(){
  LED1 = LED_OFF;
  LED2 = LED_OFF;
  LED3 = LED_OFF;
  P1DIR = P1DIR|0x07;
  P1SEL =P1SEL&0x0F8;
  return 0;
}

/**
 * LED״̬ýӿ
 * Set specified LED to specified state.
 * 
 *       vLedId: 0-n
 *       vLedState: 0 = off, 1 = on, 2 = toggle
 * return:
 *       0=success, -1 = unsupported vLedId, -2 = unsupported vLedState
 */
int8 modSetLedState(uint8 vLedId, uint8 vLedState) {
  if (vLedId>2) {
    return -1;
  }
  if (vLedState >2) {
    return -2;
  }
  if (vLedState == 0) {
    switch(vLedId)  {
      case (0):
        LED1=LED_OFF;
        break;
      case (1):
        LED2=LED_OFF;
        break;
      case (2):
        LED3=LED_OFF;
        break;
      default:
        ;
    }
  }else if (vLedState == 1) {
    switch(vLedId)  {
      case (0):
        LED1=LED_ON;
        break;
      case (1):
        LED2=LED_ON;
        break;
      case (2):
        LED3=LED_ON;
        break;
      default:
        ;
    }
  }else {
    switch(vLedId)  {
      case (0):
        LED1=!LED1;
        break;
      case (1):
        LED2=!LED2;
        break;
      case (2):
        LED3=!LED3;
        break;
      default:
        ;
    }
  }
  return 0;
}

