/*+***********************************************************
File: modRfStackImpl.c
Description: a simple wrapper for aps.c of WXL simple stack.
provide needed function only.
Modification:
2009.07.03 creation by Zheng Hui

***********************************************************-*/


#include "compiler.h"
#include "lrwpan_config.h"         //user configurations
#include "lrwpan_common_types.h"   //types common acrosss most files
#include "ieee_lrwpan_defs.h"
#include "aps.h"
#include "nwk.h"
#include "mac.h"
#include "neighbor.h"
#include <ioCC2530.h>

#include "modRfStack.h"
#include "modRf.h"
#include "lmodRfStack.h"
#include "modAdc.h"

//debug
#include "debug.h"
//
#ifndef FALSE
   #define FALSE 0
#endif
//

//extern void apsRxFSM(void); //move to aps.h

uint8 gDoService = 0;
uint8 gModStackUsrCbCalledFlag = 0;

//copy from halNeighbor.c
MAPENTRY mac_addr_tbl[LRWPAN_MAX_ADDRESS_MAP_ENTRIES];
//



/**
 * RF Stackʼӿ
 */
void modRfStackInit(void) {
  lmodInitMACTimer();
  aplInit();
  //ENABLE_GLOBAL_INTERRUPT()
  EA=(!!1);
  //set debug level
  //DEBUG_SET_LEVEL(DBG_MAX_LEVEL);
}

/**
 * RF StackЭջִнӿ
 * 2012.07.06: loop apsFSM() until idle, call apsRxFSM() seperately
* 2012.07.11: modify rx contition
 */
void modRfStackDoService(void) {
/*
  if (gDoService==1) {
    gDoService = 0;
    apsDoService();
  }else {
    apsFSM();
  }
*/
  //check tx
  if (gDoService==1) {
    gDoService = 0;
    a_aps_service.status = LRWPAN_STATUS_APS_INPROGRESS;
    apsState = APS_STATE_COMMAND_START;
  }
  myApsFSM();
  while(apsBusy()){
    myApsFSM();
  }
  //check rx
  gModStackUsrCbCalledFlag = 0;
  apsFSM();
  while ((gModStackUsrCbCalledFlag == 0)  &&((!macRxBuffEmpty())||(apsBusy()))) {//յϢδûص
    apsFSM();
  }
  while(apsBusy()){
    myApsFSM();
  }
  /*
  while ((gModStackUsrCbCalledFlag == 0)  &&(!macRxBuffEmpty())) {//յϢδûص
    apsFSM();
    //myApsRxFSM();
    while(apsBusy()){
      myApsFSM();
    }
  }
  */

}

/**
 * RF StackӿڣЭ
 */
int8 modRfStackFormNetwork(void) {
#ifdef LRWPAN_COORDINATOR
  aplFormNetwork();
  while(apsBusy()) {apsFSM();} //wait for finish
  if (aplGetStatus() == LRWPAN_STATUS_SUCCESS) {
    return 0;
  }else {
    return -1;
  }
#else
  return -1;
#endif
}

/**
 * RF Stackӿڣ·ն˵
 */
int8 modRfStackJoinNetwork(void) {
#ifndef LRWPAN_COORDINATOR
  aplJoinNetwork();
  while(apsBusy()) {apsFSM();} //wait for finish ȴɼ
  if (aplGetStatus() == LRWPAN_STATUS_SUCCESS) {   //ɹ
    return 0;
  }else {
    return -1;
  }
#else
  return -1;
#endif
}

/**
 * 󣬻ȡڵַ
 * ЭڵַΪ0x0000
 */
uint16 modRfStackGetMyShortAddress(void) {
  return aplGetMyShortAddress();
}

/**
 * 󣬻ȡڵַ
 */
uint16 modRfStackGetParentShortAddress(void) {
  return aplGetParentShortAddress();
}


/**
 * Эջ淶Ϣ
 * 2012.07.06 run stack to finish sending
 */


void modRfStackSendPkt(uint16 vDestinationId, uint8 vSize, uint8* vPacket) {
  LADDR_UNION pDestAddr;
  pDestAddr.saddr = vDestinationId;

  aplFmtSendMSG(1, &pDestAddr, 2, 0, 1, vPacket, vSize, apsGenTSN(), 0);
//  gDoService = 1;
  a_aps_service.status = LRWPAN_STATUS_APS_INPROGRESS;
  apsState = APS_STATE_COMMAND_START;
  myApsFSM();
  while(apsBusy()){
    myApsFSM();
  }

}

/**
 * Эջ淶µĽշصӿ
 */
static modRfRxCallbackFunction* mModRfStackRxUserCallback;

void modRfStackSetRxCallback(modRfRxCallbackFunction* vFunction ) {
  mModRfStackRxUserCallback = vFunction;
}


/**
 * Stack RX callback
 * 2012.07.06 add flag
 */
LRWPAN_STATUS_ENUM usrRxPacketCallback(void) {
  if (mModRfStackRxUserCallback) {
    mModRfStackRxUserCallback(aplGetRxSrcSADDR(), aplGetRxDstSADDR(), aplGetRxMsgLen(), aplGetRxMsgData(), aplGetRxRSSI() );
    gModStackUsrCbCalledFlag = 1;
  }
  return LRWPAN_STATUS_SUCCESS;
  //

}



void modApsFSM() {
  apsFSM();
}

void modSetDebugLevel(unsigned char vLevel){
#ifdef LRWPAN_DEBUG
  DEBUG_SET_LEVEL(vLevel);
#endif
}

//
#ifdef LRWPAN_FFD
//Callback to user level to see if OK for this node
//to join - implement Access Control Lists here based
//upon IEEE address if desired
BOOL usrJoinVerifyCallback(LADDR *ptr, BYTE capinfo){\
return 1;
}

BOOL usrJoinNotifyCallback(LADDR *ptr){
  return 1;
}
#endif

LRWPAN_STATUS_ENUM  usrZepRxCallback(void){
 return LRWPAN_STATUS_SUCCESS;
}

void evbIntCallback(void){
}

//called when the slow timer interrupt occurs
#ifdef LRWPAN_ENABLE_SLOW_TIMER
void usrSlowTimerInt(void ) {}
#endif


//general interrupt callback , when this is called depends on the HAL layer.
void usrIntCallback(void){}



/********************************
 * MAC TIMER: Timer2غ
 ********************************/

/**
 * ʼ
 */
//use timer2, will set it up for one tick per symbol (16us)
//assuming 2.4GHZ and a 32 MHZ clock.
void lmodInitMACTimer(void) {
  //disable Timer2
  T2CTRL = 0x02; //SYNC=1, RUN=0
  //set T2 counter overflow period to 16 us  (0x0200)
  //make sure the system clock is 32MHz
  T2MSEL=0x02; //T2MSEL[2:0]=010
  T2M0 = 0x00; //?M0 first?
  T2M1 = 0x02; //

  //start timer
  T2CTRL = 0x03; //SYNC=1, RUN=1

}

/**
 * ȡTimer2 overflow counterֵ
 */
uint32 lmodGetMACTimer(void) {
  uint32 t;
  T2MSEL = T2MSEL&(~0x70); //T2MSEL[6:4]=000
  t = 0x0FF & T2MOVF0;
  t += (((UINT16)T2MOVF1)<<8);
  t += (((UINT32) T2MOVF2)<<16);

  return t;
}

/**
 * ʼ
 */
void modInitRandomGenerator(void) {
  //enable random generator
  ADCCON1 &= ~0x0C;
  //seeded with VDD and Tempreture ADC value
  RNDL = (modAdcSampleSingle(ADC_REF_1_25_V, ADC_12_BIT, ADC_VDD_3))&0x0ff;
  RNDL = (modAdcSampleSingle(ADC_REF_AVDD, ADC_12_BIT, ADC_TEMP_SENS))&0x0ff;
  //
}

/**
 * ȡ
 */
uint8 modGetRandomByte(void) {
  ADCCON1 |= 0x04;  //advance random number
  return RNDH;
}



/**
 * ȡڵھӽڵ
 * 룺ھӽڵָ룬ھӽڵɵ߷ռ䣬ɺݣ
 * ھӽڵݣ
 * أ>=0 ھӽڵЧھӽڵ<0 
 */
int8 modGetNeighbors(MODNEIGHBORADDR* vNeighborTable ) {
  uint8 i,j,iNeighborNum=0;
  //MODNEIGHBORADDR* pNeighborTable = *(vNeighborTablePointer);
#ifdef LRWPAN_FFD
  for (i=0;i<NTENTRIES;i++) {
    if (mac_nbr_tbl[i].flags.bits.used) {
      //copy addr
      vNeighborTable[iNeighborNum].saddr = mac_addr_tbl[mac_nbr_tbl[i].map_index].saddr;
      for (j=0;j<8;j++) {
        vNeighborTable[iNeighborNum].laddr[j] = mac_addr_tbl[mac_nbr_tbl[i].map_index].laddr[j];
      }
      iNeighborNum ++;
      if (iNeighborNum>= MOD_MAX_NEIGHBORADDR_ENTRY) {
        break; //break for loop
      }
    }
  }
  return iNeighborNum;
#else
  return -1;
#endif

}
