/*+***********************************************************
File: modRfStack.h
Description: wrapper header for aps.h of MS-LRWPAN stack
Modification:
2009.07.03 creation by Zheng Hui
2012.05.06 modify according to general interface requirement
2012.07.09 add modGetNeighbors()

***********************************************************-*/

#ifndef MOD_RFSTACK_H
#define MOD_RFSTACK_H

#include "modRf.h"

/**
 * RF Stackӿʹ÷
 *   1. ԼϢmyRfStackRxCallback
 *   2. ڳʼУ
 *    a) modRfStackSetRxCallback(&myRfStackRxCallback)Ϣ
 *    b) modRfStackInit()ʼЭջ
 *   3. У
 *    a) ڵΪЭmodRfStackFormNetwork()磻
 *    b) ڵΪ·նˣmodRfStackJoinNetwork()磻
 *       modRfStackGetMyShortAddress()modRfStackGetParentShortAddress()ȡַ
 *   4. ѭУϵmodRfStackDoService()Эջ
 *   5. modRfStackSendPkt()Ϣ
 *   6. յϢʱmodRfStackDoService()ԶִûmyRfStackRxCallback
 *      
 */



/**
 * RF Stackʼӿ
 */
void modRfStackInit(void);

/**
 * RF StackЭջִнӿ
 */
void modRfStackDoService(void);

/**
 * RF StackӿڣЭ
 */
int8 modRfStackFormNetwork(void);

/**
 * RF Stackӿڣ·ն˵
 */
int8 modRfStackJoinNetwork(void);

/**
 * 󣬻ȡڵַ
 * ЭڵַΪ0x0000
 */
uint16 modRfStackGetMyShortAddress(void);

/**
 * 󣬻ȡڵַ
 */
uint16 modRfStackGetParentShortAddress(void);

/**
 * Эջ淶Ϣ
 */
void modRfStackSendPkt(uint16 vDestinationId, uint8 vSize, uint8* vPacket);

/**
 * Эջ淶µĽշصӿ
 */
void modRfStackSetRxCallback(modRfRxCallbackFunction* vFunction );

/**
 * ȡڵھӽڵ
 * 룺ھӽڵָ룬ھӽڵɵ߷ռ䣬ɺݣ
 * ھӽڵݣ
 * أ>=0 ھӽڵЧھӽڵ<0 
 */
typedef struct _MODNEIGHBORADDR {
	uint16 saddr;   //network short addr, 0xFFFF means unused
	uint8 laddr[8];	//node long mac addr      
}MODNEIGHBORADDR;
#define MOD_MAX_NEIGHBORADDR_ENTRY 50
int8 modGetNeighbors(MODNEIGHBORADDR* vNeighborTable );


/**
 * ȡӿ
 */
uint8 modGetRandomByte(void); 


#endif


